#ifndef __VPCALC_Z80_H
#define __VPCALC_Z80_H

typedef union {
	struct {
#if HOST_ENDIANESS == HOST_ENDIANESS_BE
		uint8 h, l;
#elif HOST_ENDIANESS == HOST_ENDIANESS_LE
		uint8 l, h;
#else
#error Unsupported Endianess
#endif
	} i8;
	uint16 i16;
} reg_pair;

typedef struct _core_o {
	reg_pair bc;
	uint16 bc_;

	reg_pair de;
	uint16 de_;

	reg_pair hl;
	uint16 hl_;

	reg_pair af;
	uint16 af_;

	uint16 sp;
	uint16 pc;

	reg_pair ix;
	reg_pair iy;

	uint8 i, r;
	uint8 iff1, iff2;

	int im, halted;

	int active, interrupted;

	uint16 addr;
	reg_pair *ii;

	uint8 current_opc;

/**** These are optional values to be supported by the API ****/
	int raw_avail;
	uint8 *rd, *wr, *ex;

/**** These are mandatory values to be supported by the API ****/
	timing_o *timings;
	int low_power;

	int terminate;
	int cycles;

	mem_o mem;
	dev_o dev;
} _core_o;

typedef void (*z80_opcode)(_core_o *);
typedef void (*z80_ia_opcode)(_core_o *, uint16, uint8 *);

#endif
