#ifndef __VPCALC_GFX_H
#define __VPCALC_GFX_H

typedef void *gfx_o;

gfx_o gfx_new(const char *libname, mem_o mem, uint depth, uint scale);
void gfx_del(gfx_o gfx);

void gfx_update(gfx_o gfx);
void gfx_draw(gfx_o gfx);
void gfx_palette(gfx_o gfx, int i, uint8 r, uint8 g, uint8 b);

void gfx_activate(gfx_o gfx, int value);
void gfx_set_contrast(gfx_o gfx, uint value);
void gfx_set_screen_addr(gfx_o gfx, uint scr_addr);
void gfx_map_refresh(gfx_o gfx, int *refreshing);

void gfx_write(gfx_o gfx, uint index, uint color);
uint gfx_read(gfx_o gfx, uint index);

#endif
