#ifndef __VPCALC_GRAPHICS_H
#define __VPCALC_GRAPHICS_H

typedef void *graphics_o;

graphics_o graphics_new(mem_o mem, uint depth, uint scale);
void graphics_del(graphics_o graphics);

void graphics_update(graphics_o graphics);
void graphics_draw(graphics_o graphics);
void graphics_palette(graphics_o graphics, int i, uint8 r, uint8 g, uint8 b);

void graphics_activate(graphics_o graphics, int value);
void graphics_set_contrast(graphics_o graphics, uint value);
void graphics_set_screen_addr(graphics_o graphics, uint scr_addr);
void graphics_map_refresh(graphics_o graphics, int *refreshing);

void graphics_write(graphics_o graphics, uint index, uint data);
uint graphics_read(graphics_o graphics, uint index);

#endif
